/* this file is under copyright*/
// pillbox_FULL.h automatically generated from ASMETA2CODE
#ifndef PILLBOX_FULL_H
#define PILLBOX_FULL_H

#define ARDUINOCOMPILER
#include <Arduino.h>
// The following two libs have to be installed into your Arduino Sketchbook
#include <ArduinoSTL.h>
#include <boost_1_51_0.h>
#include <string.h>				
#include <iostream> 
#include <vector> 
#include <set>
#include <map>
#include <list>
#include <boost/tuple/tuple.hpp>
using namespace std;
/*Arduino.h uses WString instead... */
#include <string.h>
#define ANY String

/* DOMAIN DEFINITIONS */
namespace pillbox_FULLnamespace {
class Compartment;
enum LedLights {
	OFF, ON, BLINKING
};

}

using namespace pillbox_FULLnamespace;

class pillbox_FULLnamespace::Compartment {
public:
	static std::set<Compartment*> elems;
	Compartment() {
		elems.insert(this);
	}
};

class pillbox_FULL {

	/* DOMAIN CONTAINERS */
	const set<LedLights> LedLights_elems;

public:
	/* FUNCTIONS */
	std::map<Compartment*, bool> openSwitch;
	std::map<Compartment*, bool> opened[2];
	std::map<Compartment*, LedLights> redLed[2];
	std::map<Compartment*, string> outMess[2];
	std::map<Compartment*, string> logMess[2];
	std::map<Compartment*, std::vector<unsigned int>> time_consumption[2];
	std::map<Compartment*, string> name[2];
	std::map<Compartment*, unsigned int> drugIndex[2];
	unsigned int systemTime;
	std::map<Compartment*, unsigned int> compartmentTimer[2];
	static Compartment* compartment1;

	static Compartment* compartment2;

	static Compartment* compartment3;

	/* RULE DEFINITION */
	void r_writeToFile_seq(Compartment* _compartment);
	void r_writeToFile(Compartment* _compartment);
	void r_pillToBeTaken_seq(Compartment* _compartment);
	void r_pillToBeTaken(Compartment* _compartment);
	void r_compartmentOpened_seq(Compartment* _compartment);
	void r_compartmentOpened(Compartment* _compartment);
	void r_pillTaken_compartmentOpened_seq(Compartment* _compartment);
	void r_pillTaken_compartmentOpened(Compartment* _compartment);
	void r_compartmentClosed_seq(Compartment* _compartment);
	void r_compartmentClosed(Compartment* _compartment);
	void r_timeOutExpired_missedPill_seq(Compartment* _compartment);
	void r_timeOutExpired_missedPill(Compartment* _compartment);
	void r_timeOutExpired_compartmentOpened_seq(Compartment* _compartment);
	void r_timeOutExpired_compartmentOpened(Compartment* _compartment);
	void r_takeInTimeout_seq(Compartment* _compartment);
	void r_takeInTimeout(Compartment* _compartment);
	void r_Main_seq();
	void r_Main();

	pillbox_FULL();

	void initControlledWithMonitored();

	void getInputs();

	void setOutputs();

	void fireUpdateSet();

};
#endif
